unit CadEntradas;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Db, DBTables, DBCtrls, Mask, Grids, DBGrids,
  ComCtrls;

type
  TFrmCadEntradas = class(TForm)
    TbEntradas: TTable;
    Bevel1: TBevel;
    BtIncluir: TBitBtn;
    BtAlterar: TBitBtn;
    BtExcluir: TBitBtn;
    BtConfirmar: TBitBtn;
    BtCancelar: TBitBtn;
    BtSair: TBitBtn;
    TbItensEntradas: TTable;
    TbEntradasNumero: TStringField;
    TbEntradasCodFornecedor: TIntegerField;
    TbEntradasDataEmissao: TDateField;
    TbEntradasDataLancamento: TDateField;
    TbItensEntradasNroEnt: TStringField;
    TbItensEntradasCodFornecedor: TIntegerField;
    TbItensEntradasCodProduto: TIntegerField;
    TbItensEntradasQuantidade: TSmallintField;
    TbItensEntradasValor: TCurrencyField;
    TbFornecedor: TTable;
    TbFornecedorCodigo: TIntegerField;
    TbFornecedorFornecedor: TStringField;
    TbFornecedorDtCadastro: TDateField;
    TbFornecedorEndereco: TStringField;
    TbFornecedorBairro: TStringField;
    TbFornecedorCidade: TStringField;
    TbFornecedorUF: TStringField;
    TbFornecedorCEP: TStringField;
    TbFornecedorCGC: TStringField;
    TbFornecedorIE: TStringField;
    TbEntradasFornecedor: TStringField;
    Label1: TLabel;
    DBEdit1: TDBEdit;
    DsEntradas: TDataSource;
    Label2: TLabel;
    DBLookupComboBox1: TDBLookupComboBox;
    Label3: TLabel;
    DBEdit2: TDBEdit;
    Label4: TLabel;
    DBEdit3: TDBEdit;
    TbProdutos: TTable;
    TbProdutosCodigo: TAutoIncField;
    TbProdutosDescricao: TStringField;
    TbProdutosModelo: TStringField;
    TbProdutosSaldo: TIntegerField;
    TbProdutosPrecoCusto: TCurrencyField;
    TbProdutosPrecoVenda: TCurrencyField;
    TbItensEntradasProduto: TStringField;
    DBGrid1: TDBGrid;
    DsItensEntradas: TDataSource;
    TbItensEntradasTotal: TCurrencyField;
    DtEntrada: TDateTimePicker;
    procedure Restaura;
    procedure BtIncluirClick(Sender: TObject);
    procedure BtAlterarClick(Sender: TObject);
    procedure BtExcluirClick(Sender: TObject);
    procedure BtConfirmarClick(Sender: TObject);
    procedure BtCancelarClick(Sender: TObject);
    procedure BtSairClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TbItensEntradasCalcFields(DataSet: TDataSet);
    Procedure Soma;
    Procedure Subtrai;
    procedure TbItensEntradasCodProdutoChange(Sender: TField);
  private
    { Private declarations }
  public
    Escolha:Char;
  end;

var
  FrmCadEntradas: TFrmCadEntradas;

implementation

uses Principal, ConsEntradas, Global;

{$R *.DFM}

Procedure TFrmCadEntradas.Soma;
Begin
TbItensEntradas.Edit;
TbItensEntradas.Post;
TbItensEntradas.First;
While not TbitensEntradas.Eof do
  Begin
    TbProdutos.FindKey([TbItensEntradasCodProduto.Value]);
    TbProdutos.Edit;
    TbProdutosSaldo.Value:=TbProdutosSaldo.Value+TbItensEntradasQuantidade.Value;
    TbProdutos.Post;
    TbItensEntradas.Next;
  End;
End;

Procedure TFrmCadEntradas.Subtrai;
Begin
TbItensEntradas.First;
While not TbitensEntradas.Eof do
  Begin
    TbProdutos.FindKey([TbItensEntradasCodProduto.Value]);
    TbProdutos.Edit;
    TbProdutosSaldo.Value:=TbProdutosSaldo.Value-TbItensEntradasQuantidade.Value;
    TbProdutos.Post;
    TbItensEntradas.Next;
  End;
End;

procedure TFrmCadEntradas.Restaura;
begin
  btincluir.enabled:= not btincluir.Enabled;
  btalterar.enabled:= not btalterar.Enabled;
  btexcluir.enabled:= not btexcluir.Enabled;
  btconfirmar.enabled:= not btconfirmar.Enabled;
  btcancelar.Enabled:= not btcancelar.Enabled;
  DsItensEntradas.Enabled:=not DsItensEntradas.Enabled;
  DsEntradas.Enabled:=not DsEntradas.Enabled; 
  DtEntrada.Enabled:=not DtEntrada.Enabled;
end;

procedure TFrmCadEntradas.BtIncluirClick(Sender: TObject);
begin
Restaura;
Escolha:='I';
FrmPrincipal.Database.StartTransaction;
TbEntradas.Append;
TbEntradasDataLancamento.Value:=Date;
TbEntradasDataEmissao.Value:=Date;
end;

procedure TFrmCadEntradas.BtAlterarClick(Sender: TObject);
begin
GlbNumero:='';
Try
   Application.CreateForm(TFrmConsEntradas, FrmConsEntradas);
   FrmConsEntradas.ShowModal;
Finally
   FrmConsEntradas.Free;
End;
if GlbNumero<>'' then
  Begin
    Restaura;
    Escolha:='A';
    FrmPrincipal.Database.StartTransaction;
    TbEntradas.FindKey([GlbNumero]);
    TbEntradas.Edit;
    Subtrai;
  End;
end;

procedure TFrmCadEntradas.BtExcluirClick(Sender: TObject);
begin
GlbNumero:='';
Try
   Application.CreateForm(TFrmConsEntradas, FrmConsEntradas);
   FrmConsEntradas.ShowModal;
Finally
   FrmConsEntradas.Free;
End;
if GlbNumero<>'' then
  Begin
    Restaura;
    Escolha:='E';
    FrmPrincipal.Database.StartTransaction;
    TbEntradas.FindKey([GlbNumero]);
    Subtrai;
  End;
end;

procedure TFrmCadEntradas.BtConfirmarClick(Sender: TObject);
begin
if (Escolha='I')or(Escolha='A') then
  Begin
    Soma;
    TbEntradas.Post;
  End
else
   begin
     While not TbItensEntradas.Eof do
       TbItensEntradas.Delete;
    TbEntradas.Delete;
   end;
  FrmPrincipal.Database.Commit;
  Restaura;
end;

procedure TFrmCadEntradas.BtCancelarClick(Sender: TObject);
begin
TbEntradas.Cancel;
FrmPrincipal.Database.Rollback;
Restaura;
end;

procedure TFrmCadEntradas.BtSairClick(Sender: TObject);
begin
Close;
end;

procedure TFrmCadEntradas.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
if btconfirmar.enabled then
  begin
     Canclose:=false;
     ShowMessage('Finalize a Operao Clicando em "Confirmar" ou "Cancelar"!');
  end;
end;

procedure TFrmCadEntradas.FormKeyPress(Sender: TObject; var Key: Char);
begin
 if Key=#13 then
  Begin
    Perform(WM_NEXTDLGCTL,0,0);
  end;
end;

procedure TFrmCadEntradas.FormShow(Sender: TObject);
begin
TbFornecedor.Open;
TbItensEntradas.Open;
TbEntradas.Open;
TbProdutos.Open;
DtEntrada.Date:=Date;
end;

procedure TFrmCadEntradas.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
TbFornecedor.Close;
TbItensEntradas.Close;
TbEntradas.Close;
TbProdutos.Close;
end;

procedure TFrmCadEntradas.TbItensEntradasCalcFields(DataSet: TDataSet);
begin
TbItensEntradasTotal.Value:=TbItensEntradasQuantidade.Value*TbItensEntradasValor.Value;
end;

procedure TFrmCadEntradas.TbItensEntradasCodProdutoChange(Sender: TField);
begin
  TbItensEntradasQuantidade.Value:=0;
end;

end.
